package com.liang.dao;

import com.liang.entity.SysRoleInfo;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (SysRoleInfo)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-19 21:37:39
 */
public interface SysRoleInfoDao {

    /**
     * 通过ID查询单条数据
     *
     * @param roleId 主键
     * @return 实例对象
     */
    SysRoleInfo queryById(Integer roleId);

    /**
     * 查询指定行数据
     *
     * @param sysRoleInfo 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<SysRoleInfo> queryAllByLimit(SysRoleInfo sysRoleInfo, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param sysRoleInfo 查询条件
     * @return 总行数
     */
    long count(SysRoleInfo sysRoleInfo);

    /**
     * 新增数据
     *
     * @param sysRoleInfo 实例对象
     * @return 影响行数
     */
    int insert(SysRoleInfo sysRoleInfo);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysRoleInfo> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SysRoleInfo> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SysRoleInfo> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SysRoleInfo> entities);

    /**
     * 修改数据
     *
     * @param sysRoleInfo 实例对象
     * @return 影响行数
     */
    int update(SysRoleInfo sysRoleInfo);

    /**
     * 通过主键删除数据
     *
     * @param roleId 主键
     * @return 影响行数
     */
    int deleteById(Integer roleId, Integer updateUser);

    List<SysRoleInfo> getSysRoleInfoList(Map map);

    /**
     * 禁用一个系统角色
     *
     * @param roleId
     * @return
     */
    int forbid(Integer roleId);

    /**
     * 启用一个系统角色
     *
     * @param roleId
     * @return
     */
    int enable(Integer roleId);

    /**
     * 批量删除
     *
     * @param
     * @return
     */
    int batchDelete(List<Integer> roleIdList, Integer updateUser);
}

